PoLiUToDroid is an extremely configurable automatic Android app GUI crawler testing tool based on a novel active learning approach.
It scan the AUT screens, find testable views, and test them using UiAutomator 2.0 and UiAutomation.

### Features ###
* Non-invasive execution.
* Human-like exploration.
* Cross-application package.
* No need of writing test script.
* Able to detect ANR and Crash.
* Able to identify NAF UI components.
* Report with logcat, screenshot and human reproducible steps (compare to monkey)
* Can dismiss common popups, including system and 3rd party.

### Screenshot folder ###
/sdcard/PoLiUToDroid/<package>/

### Run test from command line ###
adb shell am instrument -e target [package] -w com.vincenzojuniorforte.poliutodroid.test/android.support.test.runner.AndroidJUnitRunner

### Options ###
* -e target [package]                  package to be tested
* -e max-steps [number]                maximum test steps (e.g. click, scroll), default 999
* -e max-depth [number]                maximum depth from the root activity (default launchable activity), default 30
* -e max-screenshot [number]           maximum screenshot file, default 999
* -e max-screenloop [number]           maximum screens loop to avoid infinite loop, default 20
* -e max-runtime [second]              maximum run time in second, default 3600
* -e capture-steps [true|false]        take screenshot for every steps, this generate more screenshots (may duplicated), default false
* -e random-text [true|false]          input some random text to EditText if any, default true
* -e launch-timeout [millisecond]      timeout millisecond for launch app package, default 5000
* -e waitidle-timeout [millisecond]    timeout millisecond for wait app idle, default 100
* -e signature-length [number]         maximum number of characters in the signature, default 160
* -e comparison-level [1-5]            maximum comparison level to adjust the abstraction level of the GUI model, default 4
* -e fill-text [true|false]            input some text to EditText if any, default true
* -e min-sleep-action [millisecond]    minimum sleep time between consecutive actions, default 55
* -e max-sleep-action [millisecond]    maximum sleep time between consecutive actions, default 1000
* -e min-widget-percentage [number]    widget's surface threshold percentage for NAF UI components, default 1
* -e max-foreign-depth [number]        maximum depth outside of the AUT package, default 30
* -e test-naf [true|false]             test NAF UI components if any, default true

### Examples ###
\# adb shell am instrument -e target org.tomdroid -w com.vincenzojuniorforte.poliutodroid.test/android.support.test.runner.AndroidJUnitRunner