package com.vincenzojuniorforte.poliutodroid;

import java.io.File;

/**
 * Configurations
 */
public class Config {
    public static final String VERSION = "1.0.0";
    public static final String TAG = "PoLiUToDroid";
    public static final String TAG_MAIN = TAG + "Main";
    public static final String TAG_DEBUG = TAG + "Debug";

    // General settings
    public static int sMaxDepth = 30;
    public static int sMaxSteps = 999;
    public static int sMaxRuntime = 3600;
    public static int sMaxScreenshot = 999;
    public static int sMaxScreenLoop = 30;
    public static int sLaunchTimeout = 5000;
    public static int sWaitIdleTimeout = 1000;
    public static int sScreenSignatureLength = 160;
    public static long sWaitForActionAcknowledgment = 3 * 1000;

    public static boolean sMaximazeCoverage = true;

    public static boolean sDebug = true;
    public static boolean sCaptureSteps = false;
    public static boolean sRandomText = true;
    public static boolean sFillAllEditText = true;

    public static boolean sOnlyFirstChildren = false;

    public static File sOutputDir;
    public static String sFileLog;
    public static String sPerformanceLog;

    public static String sCrawlerPackage = "com.vincenzojuniorforte.poliutodroid";
    public static String sTargetPackage = "org.tomdroid";

    public static int sComparisonLevel = 4;

    // TODO: silentExecution

    // Human-like parameters
    public static int sMinSleepBetweenActions = sMaximazeCoverage ? 0 : 55;
    public static int sMaxSleepBetweenActions = sMaximazeCoverage ? 0 : 1000;
    public static int sDisplayResolution;
    public static float sMinWidgetSurfacePercentage = 1 / 100;
    public static boolean sTestAlsoNAF = false;
    public static int sDeviceId = -1;
    static {
        sTestAlsoNAF |= sMaximazeCoverage;
    }

    // For cross-apps testing
    public static int sMaxForeignDepth = 3;

    // Activities to be ignored
    public static final String[] IGNORED_ACTIVITY = {
            "Feedback & Help", "意見與協助"
    };

    // Common buttons that we can handle.
    public static final String[] COMMON_BUTTONS = {
            "OK", "Cancel", "Yes", "No",
            "確定", "取消", "是", "否"
    };

    // Common buttons that we can handle.
    public static final String[] COMMON_LONG_CLICK_STRINGS = {
            "COPY", "CUT", "PASTE", "SELECT ALL",
            "複製", "切", "糊", "全選"
    };

    // Activities to be ignored
    public static final String[] CONTAINER_CLASS = {
            "android.widget.ListView", "android.widget.GridView", "android.support.v7.widget.RecyclerView"
    };

    // Text for EditText testing
    public static final String[] RANDOM_TEXT = {
            "LOVE", "Latte", "Coffee", "Beer",
            "Taiwan", "Taipei", "Saturday", "Morning", "December",
            "Steve", "Jordan", "Michael",
            "13", "43", "51", "85", "23", "74",
            "74", "77", "17", "93"
    };
}
