package com.vincenzojuniorforte.poliutodroid.performance;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 * CPU info
 */
class CpuInfo {

    private static float totalCpuTime1 = -1f;
    private static float processCpuTime1 = -1f;

    static float getProcessCpuRate(int pid) {

        if (totalCpuTime1 == -1f) {
            totalCpuTime1 = getTotalCpuTime();
            processCpuTime1 = getAppCpuTime(pid);
            try {
                Thread.sleep(360);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }

        }

        float totalCpuTime2 = getTotalCpuTime();
        float processCpuTime2 = getAppCpuTime(pid);

        float cpuRate = 100 * (processCpuTime2 - processCpuTime1) / (totalCpuTime2 - totalCpuTime1);

        totalCpuTime1 = totalCpuTime2;
        processCpuTime1 = processCpuTime2;

        return cpuRate;
    }

    private static long getTotalCpuTime() {
        String[] cpuInfos = null;
        try {
            BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream("/proc/stat")), 1000);
            String load = reader.readLine();
            reader.close();
            cpuInfos = load.split(" ");
        } catch (IOException ex) {
            ex.printStackTrace();
        }

        long totalCpu = Long.parseLong(cpuInfos != null ? cpuInfos[2] : "0")
                + Long.parseLong(cpuInfos != null ? cpuInfos[3] : "0")
                + Long.parseLong(cpuInfos != null ? cpuInfos[4] : "0")
                + Long.parseLong(cpuInfos != null ? cpuInfos[6] : "0")
                + Long.parseLong(cpuInfos != null ? cpuInfos[5] : "0")
                + Long.parseLong(cpuInfos != null ? cpuInfos[7] : "0")
                + Long.parseLong(cpuInfos != null ? cpuInfos[8] : "0");

        return totalCpu;
    }

    private static long getAppCpuTime(int pid) {
        String[] cpuInfos = null;
        try {
            BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream("/proc/" + pid + "/stat")), 1000);
            String load = reader.readLine();
            reader.close();
            cpuInfos = load.split(" ");
        } catch (IOException ex) {
            ex.printStackTrace();
        }

        long appCpuTime = Long.parseLong(cpuInfos != null ? cpuInfos[13] : "0")
                + Long.parseLong(cpuInfos != null ? cpuInfos[14] : "0")
                + Long.parseLong(cpuInfos != null ? cpuInfos[15] : "0")
                + Long.parseLong(cpuInfos != null ? cpuInfos[16] : "0");

        return appCpuTime;
    }
}
